"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.detectPackageManager = exports.checkForLockfiles = void 0;
const fs_1 = require("fs");
const promises_1 = require("fs/promises");
const path_1 = require("path");
const checkForLockfiles = (directory) => {
    const lockfiles = [
        { type: "yarn", file: "yarn.lock" },
        { type: "pnpm", file: "pnpm-lock.yaml" },
        { type: "npm", file: "package-lock.json" },
        { type: "npm", file: "npm-shrinkwrap.json" },
    ];
    const fileChecks = lockfiles.map((lockfile) => __awaiter(void 0, void 0, void 0, function* () {
        return (Object.assign(Object.assign({}, lockfile), { exists: yield (0, promises_1.access)((0, path_1.resolve)(directory, lockfile.file), fs_1.constants.F_OK)
                .then(() => true)
                .catch(() => false) }));
    }));
    return Promise.all(fileChecks);
};
exports.checkForLockfiles = checkForLockfiles;
const detectPackageManager = (directory, preference) => __awaiter(void 0, void 0, void 0, function* () {
    var _a;
    if (preference) {
        return preference;
    }
    const fileCheckResults = yield (0, exports.checkForLockfiles)(directory);
    const packageManagersWithLockfiles = [
        ...new Set(fileCheckResults.filter(({ exists }) => exists).map(({ type }) => type)),
    ];
    return (_a = packageManagersWithLockfiles[0]) !== null && _a !== void 0 ? _a : "pnpm";
});
exports.detectPackageManager = detectPackageManager;
