import { PackageManager } from "./detectPackageManager";
export declare type InstallPackageOptions = {
    /** The directory of the project where the packages will be added
     *
     * @default process.cwd()
     */
    directory?: string;
    /** Specify the type of dependency. Peer dependencys also get added to the dev dependencies.
     *
     * `normal` => `dependencies`
     *
     * `dev` => `devDependencies`
     *
     * `optional` => `optionalDependencies`
     *
     * `peer` => `peerDependencies` __&__ `devDependencies`
     *
     * @default "normal"
     */
    type?: "normal" | "dev" | "optional" | "peer";
};
export declare type SelectPackageManagerOptions = {
    /** Select your preferred package manager.
     * If not set it will be detected automatically.
     * If it can not be detected it will fallback to `pnpm`
     */
    packageManager?: PackageManager;
};
export declare const installPackage: (packages: string | string[], options?: InstallPackageOptions & SelectPackageManagerOptions) => Promise<void | {
    package: string;
    wantedVersion: string;
    wantedBy: {
        package: string;
        version: string;
    }[];
    installedVersion?: string | undefined;
    optional: boolean;
}[]>;
