"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.installPackage = void 0;
const detectPackageManager_1 = require("./detectPackageManager");
const installPackageNpm_1 = require("./installPackageNpm");
const installPackagePnpm_1 = require("./installPackagePnpm");
const installPackageYarn_1 = require("./installPackageYarn");
const installPackage = (packages, options) => __awaiter(void 0, void 0, void 0, function* () {
    var _a;
    const packagesArray = Array.isArray(packages) ? packages : [packages];
    const directory = (_a = options === null || options === void 0 ? void 0 : options.directory) !== null && _a !== void 0 ? _a : process.cwd();
    const packageManager = yield (0, detectPackageManager_1.detectPackageManager)(directory, options === null || options === void 0 ? void 0 : options.packageManager);
    const installPackageFunctions = {
        pnpm: installPackagePnpm_1.installPackagePnpm,
        yarn: installPackageYarn_1.installPackageYarn,
        npm: installPackageNpm_1.installPackageNpm,
    };
    const installPackageFunction = installPackageFunctions[packageManager];
    return installPackageFunction(packagesArray, options);
});
exports.installPackage = installPackage;
