"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.installPackageYarn = void 0;
// @ts-expect-error: No types available for arborist
const arborist_1 = require("@npmcli/arborist");
// @ts-expect-error: No types available for arborist
const yarn_lock_1 = __importDefault(require("@npmcli/arborist/lib/yarn-lock"));
const parse_wanted_dependency_1 = __importDefault(require("@pnpm/parse-wanted-dependency"));
const promises_1 = require("fs/promises");
const path_1 = require("path");
const installPackageYarn = (packages, options) => __awaiter(void 0, void 0, void 0, function* () {
    var _a, _b, _c;
    const packagesArray = Array.isArray(packages) ? packages : [packages];
    const directory = (_a = options === null || options === void 0 ? void 0 : options.directory) !== null && _a !== void 0 ? _a : process.cwd();
    const type = (_b = options === null || options === void 0 ? void 0 : options.type) !== null && _b !== void 0 ? _b : "normal";
    // const yarn = false
    const saveType = {
        normal: "prod",
        dev: "dev",
        optional: "optional",
        peer: "peer",
    }[type];
    const arb = new arborist_1.Arborist({
        path: directory,
        packageLockOnly: true,
        force: true,
    });
    yield arb.buildIdealTree({
        add: packagesArray,
        saveType: saveType,
    });
    if (saveType === "peer") {
        const wantedDependencies = packagesArray.map(packageName => { var _a; return (_a = (0, parse_wanted_dependency_1.default)(packageName).alias) !== null && _a !== void 0 ? _a : ""; });
        arb.idealTree.package.devDependencies = wantedDependencies.reduce((previous, name) => (Object.assign(Object.assign({}, previous), { [name]: arb.idealTree.package.peerDependencies[name] })), (_c = arb.idealTree.package.devDependencies) !== null && _c !== void 0 ? _c : {});
    }
    if (arb.idealTree && !arb.idealTree.meta.yarnLock) {
        arb.idealTree.meta.yarnLock = new yarn_lock_1.default();
        arb.idealTree.meta.yarnLock.fromTree(arb.idealTree);
    }
    yield arb.reify({ save: true, packageLockOnly: true });
    yield (0, promises_1.rm)((0, path_1.resolve)(directory, "package-lock.json"), { force: true });
});
exports.installPackageYarn = installPackageYarn;
