import { SelectPackageManagerOptions } from "./installPackage";
export declare type RemovePackageOptions = {
    /** The directory of the project from which the packages will be removed
     *
     * @default process.cwd()
     */
    directory?: string;
    /** Specify the type of dependency. To remove peer dependencies you have to keep thsi empty or select all
     *
     * `all` =>  `dependencies` & `devDependencies` & `optionalDependencies` & `peerDependencies`
     *
     * `normal` => `dependencies`
     *
     * `dev` => `devDependencies`
     *
     * `optional` => `optionalDependencies`
     *
     * @default "all"
     */
    type?: "all" | "normal" | "dev" | "optional";
};
export declare const removePackage: (packages: string | string[], options?: RemovePackageOptions & SelectPackageManagerOptions) => Promise<void | {
    package: string;
    wantedVersion: string;
    wantedBy: {
        package: string;
        version: string;
    }[];
    installedVersion?: string | undefined;
    optional: boolean;
}[]>;
