"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.removePackageNpm = void 0;
// @ts-expect-error: No types available for arborist
const arborist_1 = require("@npmcli/arborist");
// @ts-expect-error: No types available for arborist
const add_rm_pkg_deps_1 = require("@npmcli/arborist/lib/add-rm-pkg-deps");
const defaultTypeMap = {
    dev: "devDependencies",
    optional: "optionalDependencies",
    prod: "dependencies",
    peerOptional: "peerDependencies",
    peer: "peerDependencies",
};
const withMessedUpTypemap = (tempTypemap, action) => __awaiter(void 0, void 0, void 0, function* () {
    const typemap = add_rm_pkg_deps_1.saveTypeMap;
    try {
        Object.entries(tempTypemap).forEach(([key, value]) => {
            typemap.set(key, value);
        });
        return yield action();
    }
    finally {
        Object.entries(defaultTypeMap).forEach(([key, value]) => {
            typemap.set(key, value);
        });
    }
});
const removePackageNpm = (packages, options) => __awaiter(void 0, void 0, void 0, function* () {
    var _a, _b;
    const packagesArray = Array.isArray(packages) ? packages : [packages];
    const directory = (_a = options === null || options === void 0 ? void 0 : options.directory) !== null && _a !== void 0 ? _a : process.cwd();
    const type = (_b = options === null || options === void 0 ? void 0 : options.type) !== null && _b !== void 0 ? _b : "all";
    const arb = new arborist_1.Arborist({
        path: directory,
        packageLockOnly: true,
        force: true,
    });
    yield arb.loadActual();
    const typemap = type === "dev"
        ? {
            dev: "devDependencies",
            optional: "devDependencies",
            prod: "devDependencies",
            peerOptional: "devDependencies",
            peer: "peerDependencies",
        }
        : type === "normal"
            ? {
                dev: "dependencies",
                optional: "dependencies",
                prod: "dependencies",
                peerOptional: "dependencies",
                peer: "dependencies",
            }
            : type === "optional"
                ? {
                    dev: "optionalDependencies",
                    optional: "optionalDependencies",
                    prod: "optionalDependencies",
                    peerOptional: "optionalDependencies",
                    peer: "optionalDependencies",
                }
                : defaultTypeMap;
    yield withMessedUpTypemap(typemap, () => __awaiter(void 0, void 0, void 0, function* () {
        return yield arb.buildIdealTree({
            rm: packagesArray,
        });
    }));
    yield arb.reify({ save: true, packageLockOnly: true });
});
exports.removePackageNpm = removePackageNpm;
