"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.simplifyPeerDependencyIssues = void 0;
/** Reduce pnpm PeerDependencyIssues to a single array*/
const simplifyPeerDependencyIssues = (issues) => {
    const peerDepIssues = [...Object.entries(issues.bad), ...Object.entries(issues.missing)].flatMap(([name, issues]) => issues.map(issue => ({
        package: name,
        wantedVersion: issue.wantedRange,
        wantedBy: issue.parents.map(({ name, version }) => ({ package: name, version })),
        installedVersion: issue.foundVersion,
        optional: issue.optional,
    })));
    return peerDepIssues;
};
exports.simplifyPeerDependencyIssues = simplifyPeerDependencyIssues;
